//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DodgerBlue
#property indicator_color2  Red
#property indicator_color3  Aqua
#property indicator_color4  Magenta

//
//
//
//
//

extern int    EnvelopePeriod  = 20;
extern int    EnvelopeMaShift = 0;
extern int    EnvelopeMaMode  = MODE_EMA;
extern int    UpperPrice      = 0;
extern int    LowerPrice      = 0;
extern double Deviation       = 0.15;
extern int    arrowSize       = 2;

//
//
//
//
//

double arrowUp[];
double arrowDn[];
double UpEnv[];
double DnEnv[];

//
//
//
//                    
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,UpEnv);   SetIndexShift(0,EnvelopeMaShift);
   SetIndexBuffer(1,DnEnv);   SetIndexShift(1,EnvelopeMaShift);
   SetIndexBuffer(2,arrowUp); SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,241);
   SetIndexBuffer(3,arrowDn); SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,242);
   IndicatorShortName("Envelope("+EnvelopePeriod+")");
   
   
return(0);
}  
  
//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0; i--)
   {
      UpEnv[i] = (1+Deviation/100)*iMA(NULL,0,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,UpperPrice,i);
      DnEnv[i] = (1-Deviation/100)*iMA(NULL,0,EnvelopePeriod,EnvelopeMaShift,EnvelopeMaMode,LowerPrice,i);
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         if ( Low[i]<DnEnv[i]) arrowUp[i] = DnEnv[i] - iATR(NULL,0,20,i)/2;
         if (High[i]>UpEnv[i]) arrowDn[i] = UpEnv[i] + iATR(NULL,0,20,i)/2;
    }
return(0);
}


